import * as cloudwatch from 'aws-cdk-lib/aws-cloudwatch';
/**
 * @stability stable
 */
export interface IWatchful {
    /**
     * @stability stable
     */
    addSection(title: string, options?: SectionOptions): void;
    /**
     * @stability stable
     */
    addAlarm(alarm: cloudwatch.IAlarm): void;
    /**
     * @stability stable
     */
    addWidgets(...widgets: cloudwatch.IWidget[]): void;
}
/**
 * @stability stable
 */
export interface SectionOptions {
    /**
     * @stability stable
     */
    readonly links?: QuickLink[];
}
/**
 * @stability stable
 */
export interface QuickLink {
    /**
     * @stability stable
     */
    readonly title: string;
    /**
     * @stability stable
     */
    readonly url: string;
}
